function [flag,deter]=hurwitz(p)

%construct Hurwitz matrices
pp=p;
if length(p)==2
    error('Hurwitz criterion is not necessary.');
else
    n=length(p)-1;
    h=zeros(n);
    if ~mod(n,2)
       pp=[p 0];
    end
    r=reshape(pp,2,length(pp)/2);
    r=[r(2,:);r(1,:)];
    for k=2:2:n
        h(k-1:k,k/2:(k/2+length(pp)/2-1))=r;
    end
    if mod(n,2)
        h(n,(n+1)/2:((n+1)/2+length(pp)/2-1))=r(1,:);
    end
end

%calculate determinants
for k=1:2:n
    deter((k+1)/2)=det(h(1:k,1:k));
end

%judge stability
if prod((deter>0).^2)
    flag='stable';
else
    flag='unstable';
end